head	2.7;
access;
symbols;
locks;
comment	@ * @;


2.7
date	2011.05.19.15.10.25;	author Average;	state Exp;
branches;
next	2.6;

2.6
date	2011.05.18.13.05.31;	author Average;	state Exp;
branches;
next	2.5;

2.5
date	2011.05.17.16.43.00;	author Average;	state Exp;
branches;
next	2.4;

2.4
date	2011.05.17.16.20.32;	author Average;	state Exp;
branches;
next	2.3;

2.3
date	2011.05.17.16.11.31;	author Average;	state Exp;
branches;
next	2.2;

2.2
date	2011.05.17.15.02.11;	author Average;	state Exp;
branches;
next	2.1;

2.1
date	2011.05.17.14.12.30;	author Average;	state Exp;
branches;
next	1.5;

1.5
date	2011.05.17.14.11.23;	author Average;	state Exp;
branches;
next	1.4;

1.4
date	2011.05.17.14.09.57;	author Average;	state Exp;
branches;
next	1.3;

1.3
date	2011.05.17.14.08.53;	author Average;	state Exp;
branches;
next	1.2;

1.2
date	2011.05.17.14.07.45;	author Average;	state Exp;
branches;
next	1.1;

1.1
date	2011.05.16.14.02.05;	author Average;	state Exp;
branches;
next	;


desc
@@


2.7
log
@Ƃ肠ArtifyɓꍞނƂ͐
@
text
@UNIT MLTUNIT;

INTERFACE
{$H+}
USES
Classes,SysUtils,Math,MkBMP,VPUtils;

CONST
    ConstLengthLimit=1e15;
    ConstLengthFar=1e30;
    ConstPlaneLimit=1e-10;
    ConstEpsilon=1e-3;
    MaxDepth=10;
    VacuumRefractiveIndex=1.0;

TYPE
    ColorType=RECORD
        r,g,b:BYTE;
    END;
    VectorRecord=Record
        x,y,z:SINGLE;
    end;
    SpectrumRecord=record
        r,g,b:SINGLE;
    end;

    RayRecord=Record
        Org,Dir:VectorRecord;
    END;

    MaterialRecord=Record
        col:SpectrumRecord;
        reflection:single;
        refraction:single;
        RefractiveRate :single;  // ܗ
        EmissionColor:SpectrumRecord;
    END;

    // J
    CameraRecord=Record
        eye, origin, xaxis, yaxis:VectorRecord;
    end;



    LightClass=CLASS
        pos:VectorRecord;
        power:SpectrumRecord;
        constructor Create(pos_:VectorRecord;power_:SpectrumRecord);
    END;

    IntersectionRecord=Record
        t:single;
        p,n:VectorRecord;
        Material:MaterialRecord;
    end;

    IntersectableClass=CLASS
        constructor Create;virtual;abstract;
        function Intersect(var isect:IntersectionRecord;
                           Ray:RayRecord):boolean;virtual;abstract;
    END;

    SphereClass=CLASS(IntersectableClass)
        center:VectorRecord;
        radius:single;
        Material:MaterialRecord;

        constructor Create(center_:VectorRecord;
                           radius_:single;
                           Material_:MaterialRecord);virtual;
        function Intersect(var isect:IntersectionRecord;
                           Ray:RayRecord):boolean;override;

    end;
    PlaneClass=CLASS(IntersectableClass)
        n:VectorRecord;
        d:single;
        Material:MaterialRecord;
        constructor Create(p_,n_:VectorRecord;
                           Material_:MaterialRecord);virtual;
        function Intersect(var isect:IntersectionRecord;
                           ray:RayRecord):boolean;override;
    end;

    CheckedPlaneClass=CLASS(PlaneClass)
        InvGridSize:single;
        Material2:MaterialRecord;
        constructor Create(p_,n_:VectorRecord;
                           GridSize:single;
                           Material_,Material2_:MaterialRecord);virtual;
        function Intersect(var isect:IntersectionRecord;
                           ray:RayRecord):boolean;override;
    end;

    SceneClass=Class
        Black,SkyColor:SpectrumRecord;
        LightList,ObjList:TList;
        constructor Create;
        procedure AddObj(OB:IntersectableClass);
        procedure AddLight(Light:LightClass);
        function random_dir_over_hemisphere(n:VectorRecord):VectorRecord;
        function Trace(ray:RayRecord;Depth:integer):SpectrumRecord;
        function FindNearestIntersectionRecord(ray:RayRecord):IntersectionRecord;
        function lighting(p,n:VectorRecord;m:MaterialRecord):SpectrumRecord;
        function Visible(Org,Target:VectorRecord):boolean;
        FUNCTION DiffuseLighting(p,n,lightPos:VectorRecord;
                                 DiffuseColor,
                                 LightPower:SpectrumRecord):SpectrumRecord;
    end;


function CreateVector(x_,y_,z_:SINGLE):VectorRecord;
FUNCTION VecAdd(V1,V2 :VectorRecord):VectorRecord;
FUNCTION VecSub(Vo,Vs :VectorRecord):VectorRecord;
FUNCTION VecScale(V:VectorRecord;S :SINGLE):VectorRecord;
FUNCTION VecNeg(v:VectorRecord):VectorRecord;
FUNCTION Veclen(v:VectorRecord):SINGLE;
FUNCTION VecNormalize(V:VectorRecord):VectorRecord;
FUNCTION VecDot(V1,V2 :VectorRecord):SINGLE;//
FUNCTION VecCross(V1,V2 :VectorRecord):VectorRecord;//O


function CreateSpectrum(r_,g_,b_:SINGLE):SpectrumRecord;
FUNCTION SpecAdd(v1,v2:SpectrumRecord):SpectrumRecord;
FUNCTION SpecMul(v1,v2:SpectrumRecord):SpectrumRecord;
FUNCTION SpecScale(v:SpectrumRecord;s:SINGLE):SpectrumRecord;
FUNCTION SpecToColor(v:SpectrumRecord):ColorType;

function  CreateMaterial(col_:SpectrumRecord):MaterialRecord;

function CreateIntersect:IntersectionRecord;
function HitIntersect(isect:IntersectionRecord):boolean;

function CreateRay(o,d:VectorRecord):RayRecord;

        procedure CameraLookat(
                         var CM:CameraRecord;
                         eye_,target,up:VectorRecord;
                         fov:single;
                         width,height:integer);
        function GetCameraRay(CM:CameraRecord;x,y:single):RayRecord;


IMPLEMENTATION



function CreateVector(x_,y_,z_:SINGLE):VectorRecord;
BEGIN
    result.x:=x_;result.y:=y_;result.z:=z_;
END;
FUNCTION VecAdd(V1,V2 :VectorRecord):VectorRecord;
BEGIN
    result.x:=V1.x+V2.x;
    result.y:=V1.y+V2.y;
    result.z:=V1.z+V2.z;
END;
FUNCTION VecSub(Vo,Vs :VectorRecord):VectorRecord;
BEGIN
    result.x:=Vo.x-Vs.x;
    result.y:=Vo.y-Vs.y;
    result.z:=Vo.z-Vs.z;
END;
FUNCTION VecScale(V:VectorRecord;S :SINGLE):VectorRecord;
BEGIN
    result.x:=V.x*s;
    result.y:=V.y*s;
    result.z:=V.z*s;
END;
FUNCTION VecNeg(V:VectorRecord):VectorRecord;
BEGIN
    result.x:=-V.x;
    result.y:=-V.y;
    result.z:=-V.z;
END;
FUNCTION Veclen(V:VectorRecord):SINGLE;
BEGIN
   result:=sqrt(V.x*V.x+V.y*V.y+V.z*V.z);
END;

FUNCTION VecNormalize(V:VectorRecord):VectorRecord;
BEGIN
    result:=Vecscale(V,1.0/VecLen(V) );
END;
FUNCTION VecDot(V1,V2 :VectorRecord):SINGLE;//
BEGIN
    result:=v1.x*v2.x+v1.y*v2.y+v1.z*v2.z;
END;
FUNCTION VecCross(V1,V2 :VectorRecord):VectorRecord;//O
BEGIN
    result.x:=V1.y * v2.z - v2.y * V1.z;
    result.y:=V1.z * v2.x - v2.z * V1.x;
    result.z:=V1.x * v2.y - v2.x * V1.y;
END;


function CreateSpectrum(r_, g_, b_:SINGLE):SpectrumRecord;
BEGIN
    result.r := r_;
    result.g := g_;
    result.b := b_;
END;

FUNCTION SpecAdd(v1,v2:SpectrumRecord):SpectrumRecord;
BEGIN
    result.r:=v1.r + v2.r;
    result.g:=v1.g + v2.g;
    result.b:=v1.b + v2.b;
END;

FUNCTION SpecMul(v1,v2:SpectrumRecord):SpectrumRecord;
BEGIN
    result.r:=v1.r * v2.r;
    result.g:=v1.g * v2.g;
    result.b:=v1.b * v2.b;
END;
FUNCTION SpecScale(v:SpectrumRecord;s:SINGLE):SpectrumRecord;
BEGIN
    result.r:=v.r * s;
    result.g:=v.g * s;
    result.b:=v.b * s;
END;
FUNCTION SpecToColor(v:SpectrumRecord):ColorType;
VAR
    i:ColorType;
    FUNCTION RealToByte(r:SINGLE):BYTE;
    BEGIN
        IF r>255 THEN r:=255;
        result:=Trunc(r);
    END;
BEGIN
    i.r := RealToByte(v.r * 255);
    i.g := RealToByte(v.g * 255);
    i.b := RealToByte(v.b * 255);
    result:=i;
END;


function CreateRay(o,d:VectorRecord):RayRecord;
begin
    result.org:=o;
    result.dir:=d;
end;

function CreateMaterial(col_:SpectrumRecord):MaterialRecord;
begin
    result.col:=col_;
    result.reflection:=0; //˗
    result.refraction:=0; //܂̊
    result.RefractiveRate := 1;  // ܗ
    result.EmissionColor.r:=0;
    result.EmissionColor.g:=0;
    result.EmissionColor.b:=0;

end;

constructor LightClass.Create(pos_:VectorRecord;power_:SpectrumRecord);
begin
    pos:=pos_;
    power:=power_;
end;

function CreateIntersect:IntersectionRecord;
begin
    result.t:=ConstLengthFar;
end;

function HitIntersect(isect:IntersectionRecord):boolean;
begin
    result:=((isect.t<0) or (isect.t<ConstLengthLimit));
end;

constructor SphereClass.Create(center_:VectorRecord;
                               radius_:single;
                               Material_:MaterialRecord);
begin
    center:=center_;
    radius:=radius_;
    material:=material_;
end;

function SphereClass.Intersect(var isect:IntersectionRecord;
                                Ray:RayRecord):boolean;
var
    o_c:VectorRecord;
    b,c,d,dR,t:single;
begin

    result:=FALSE;
    o_c:=VecSub(ray.org,center);
    b:=VecDot(ray.dir,o_c);
    c:=VecDot(o_c,o_c)-sqr(radius);
    d:=b*b-c;
    IF d>=0 then begin
        dR:=sqrt(d);
        t:=-b-dR;
        IF t<=ConstEpsilon then t:=-B+dR;
        IF ((t>ConstEpsilon) and (isect.t>t)) then begin
            isect.t:=t;
            isect.p:=VecAdd(ray.org,VecScale(ray.dir,t));
            isect.n:=VecNormalize(VecSub(isect.p,center) );
            isect.material:=material;
            result:=TRUE;
            exit;
        end;
    end;
end;

constructor PlaneClass.Create(p_,n_:VectorRecord;
                              Material_:MaterialRecord);
begin
    n := VecNormalize(n_);
    d := -VecDot(p_,n);
    Material:=Material_;
end;

function PlaneClass.Intersect(var isect:IntersectionRecord;ray:RayRecord):boolean;
var
    v,t:single;
begin
    result:=FALSE;
    v:=VecDot(n,ray.dir);
    IF abs(v)<ConstPlaneLimit then begin
        result:=false;
        exit;
    end;
    t:=-(VecDot(n,ray.org)+d)/v;
    if ((t>ConstEpsilon)and(isect.t>t)) then begin
        isect.t:=t;
        isect.p:=VecAdd(ray.org,VecScale(ray.dir,t));
        isect.n:=n;
        isect.material:=material;
        result:=TRUE;
        exit;
    end;
end;

constructor CheckedPlaneClass.Create(p_,n_:VectorRecord;
                                     GridSize:single;
                                     Material_,Material2_:MaterialRecord);
begin
    inherited Create(p_,n_,Material_);
    InvGridSize:=1/GridSize;
    Material2:=Material2_;
end;

function CheckedPlaneClass.Intersect(var isect:IntersectionRecord;
                                     ray:RayRecord):boolean;
var
    i:integer;
begin
    result:=false;
    if inherited Intersect(isect,ray) then begin
        result:=true;
        i:=floor(isect.p.x*InvGridSize)
          +floor(isect.p.y*InvGridSize)
          +floor(isect.p.z*InvGridSize);
        IF odd(i) then isect.material:=Material2;
    end;

end;


// J

  // _炠ʒu悤ɐݒs
procedure CameraLookat(var CM:CameraRecord;
                       eye_,target,up:VectorRecord;
                       fov:single;
                       width,height:integer);
var
    imageplane:single;
    t_o,center:VectorRecord;
begin
    CM.eye := eye_;
    imageplane := (height / 2) / tan(fov / 2);
    t_o := VecNormalize(VecSub(target,CM.eye));
    CM.xaxis := VecNormalize(VecCross(t_o,up));
    CM.yaxis := VecCross(t_o,CM.xaxis);
    center := VecScale(t_o,imageplane);
    CM.origin := VecSub(
                    VecSub(center,VecScale(CM.xaxis,(0.5 * width)) ),
                    VecScale(CM.yaxis,(0.5 * height))
                 );
end;

function GetCameraRay(CM:CameraRecord;x,y:single):RayRecord;
var
    dir:VectorRecord;
begin
    dir:= VecNormalize(
                VecAdd(VecAdd(CM.origin,VecScale(CM.xaxis,x)),
                       (VecScale(CM.yaxis,y)))
          );
    result:=CreateRay(CM.eye, dir);
end;


constructor SceneClass.Create;
begin
    ObjList:=TList.Create;
    LightList:=TList.Create;
    Black:=CreateSpectrum(0,0,0);
    SkyColor:=CreateSpectrum(0.7,0.75,0.8);
end;

procedure SceneClass.AddObj(OB:IntersectableClass);
begin
    ObjList.Add(OB);
end;

procedure SceneClass.AddLight(Light:LightClass);
begin
    LightList.Add(Light);
end;


// ̃_ȕ肷
function SceneClass.random_dir_over_hemisphere(n:VectorRecord):VectorRecord;
var
    x,y,z:single;
    ll:single;
begin
    while true do begin
        x:=(random(2000)-1000);x:=x/1000;
        y:=(random(2000)-1000);y:=y/1000;
        z:=(random(2000)-1000);z:=z/1000;
        ll:=x*x+y*y+z*z;
        if ((ll>0)and(ll<1.0)) THEN BEGIN
            ll:=Sqrt(ll);
            result.x:=x/ll;
            result.y:=y/ll;
            result.z:=z/ll;

            IF VecDot(result,n)<0 then result:=VecNeg(result);
            exit;
        END;
    end;
end;


function SceneClass.Trace(ray:RayRecord;Depth:integer):SpectrumRecord;
    // gU˖ʂ̔ˌvZ
    function TraceDiffuseReflection(p,n:VectorRecord;
                                    diffuse_color:SpectrumRecord;
                                    depth:integer):SpectrumRecord;
    var
        r:VectorRecord;
        Li,fr:SpectrumRecord;
        m:materialRecord;
        dot:single;
    begin
    // _̖@@ɑ΂āÃ_ȕɃC΂
        r:=random_dir_over_hemisphere(n);
        Li := trace( CreateRay(p, r), depth);
        fr := SpecScale(diffuse_color,1.0 / PI);
        dot := VecDot(n,r);
        result:=SpecScale( SpecMul(Li,fr),2 * PI * dot);
    end;
    function reflect(v, n:VectorRecord):VectorRecord;
    begin
        result:= VecSub(v,(VecScale(n,(2 * VecDot(v,n)))));
    end;
    function TraceReflection(p,n,v:VectorRecord;depth:integer):SpectrumRecord;
    var
        r:VectorRecord;
    begin
        r := reflect(v, n);
        result:=trace(CreateRay(p, r), depth);
    end;
    function refract(var isOK:boolean;v,n:VectorRecord;eta_i,eta_t:single):VectorRecord;
    var
       VdotN,eta,d:single;
       a,b:VectorRecord;
    begin
        isOK:=true;
        VdotN := VecDot(v,n);
        eta := eta_i / eta_t;
        d := 1.0 - sqr(eta) * (1.0 - sqr(VdotN));
        IF d>0 then begin
            a := VecSub(v,( VecScale(VecScale(n,VdotN),eta) ));
            b := VecScale(n,sqrt(d));
            result:=VecSub(a,b);
            exit;
        end;
        isOK:=FALSE;
    end;

    function TraceRefraction(p,n,v:VectorRecord;
                             eta_i,eta_t:single;
                             depth:integer):SpectrumRecord;
    var
        r:VectorRecord;
        isOk:boolean;
    begin
        r:=refract(isOK,v,n,eta_i,eta_t);
        IF isOK then
           // 
           result:=trace(CreateRay(p,r),depth)
        else
           // S
           result:=TraceReflection(p, n, v, depth);
    end;
    function interact_surface(raydir,p,n:VectorRecord;
                              m:MaterialRecord;
                              eta_i, eta_t:single;
                              depth:integer):SpectrumRecord;
    var
       ks,kt,kd:single;
       t:single;
       c:SpectrumRecord;
    begin
        ks := m.reflection;
        kt := m.refraction;
        kd := 1.0 - ks - kt;
    // [1] ʔˁE܁EgU˂̉exɉĂ̂̈I
        t := random(1000)/1000;
        IF t<ks then begin
            c:=TraceReflection(p,n,raydir,depth)  ;
            result:=SpecMul(c,m.col);
            exit;
        end;
        IF t<(ks+kt) then begin
            c := TraceRefraction(p, n, raydir, eta_i, eta_t, depth);
            result:=SpecMul(c,m.col);
            exit;
        end;
        result:=TraceDiffuseReflection(p, n, m.col, depth);
    end;
var
    isect:IntersectionRecord;
    m:MaterialRecord;
    L,c,Col:SpectrumRecord;
    ks,kd,kt:single;
    dot:single;
begin
    Depth:=Depth+1;
    IF Depth>MaxDepth then begin
        result:=Black;
        exit;
    end;
    isect := FindNearestIntersectionRecord(ray);
    IF HitIntersect(isect)=FALSE then begin
        result:=SkyColor;
        exit;
    end;
    m:= isect.material;
    dot := VecDot(isect.n,ray.dir);
    if (dot < 0) THEN BEGIN  // ̂ɊO瓖
        col := interact_surface(ray.dir, isect.p, isect.n, m, VacuumRefractiveIndex, m.RefractiveRate, depth);
        result:=SpecAdd(col, SpecScale(m.EmissionColor,-dot));
        exit;
    end
    ELSE
        // ̂očs
        result:=interact_surface(ray.dir, isect.p, VecNeg(isect.n), m, m.RefractiveRate, VacuumRefractiveIndex, depth);

{*****
    m := isect.material;
    IF (isect.n.dot(ray.dir)<0) THEN BEGIN
        L:=Black;
        ks:= m.reflection;
        if (ks > 0) THEN BEGIN
           c := TraceReflection(isect.p, isect.n, ray.dir, depth);
           L := L.add(c.scale(ks).mul(m.col));
        END;
        kt := m.refraction;
        IF (kt>0) THEN BEGIN
            c:=TraceRefraction(isect.p,isect.n,Ray.dir,
                               VacuumRefractiveIndex,
                               m.RefractiveRate,
                               Depth);
            L:=L.add(c.scale(kt).mul(m.col));
        END;
        kd := 1- ks -kt ;
        if (kd > 0) THEN BEGIN
           c := lighting(isect.p, isect.n, isect.material);
           L := L.add(c.scale(kd));
        END;
        result:=L;
    END
    ELSE
        result:=TraceRefraction(isect.p, isect.n.neg, ray.dir,
                                m.RefractiveRate,
                                VacuumRefractiveIndex, depth);
****}
end;

function SceneClass.FindNearestIntersectionRecord(ray:RayRecord):IntersectionRecord;
var
    isect:IntersectionRecord;
    i:integer;
    OBJ:IntersectableClass;
begin
    isect := CreateIntersect;
    i:=0;
    while i<ObjList.count do begin
      OBJ:=IntersectableClass(ObjList[i]);
      obj.intersect(isect, ray);
      i:=i+1;
    end;
    result:=isect;
end;
function SceneClass.lighting(p,n:VectorRecord;m:MaterialRecord):SpectrumRecord;
var
    L,c:SpectrumRecord;
    Light:LightClass;
    i:integer;
begin
    L:=Black;//SpectrumRecord.Create(0,0,0);
    i:=0;
    while i<LightList.count do begin
        Light:=LightClass(LightList[i]);
        c:=DiffuseLighting(p,n,Light.pos,m.col,Light.power);
        L:=SpecAdd(L,c);
        i:=i+1;
    end;
    result:=L;
end;
function SceneClass.Visible(Org,Target:VectorRecord):boolean;
var
    t_o:VectorRecord;
    ShadowRay:RayRecord;
    isect:IntersectionRecord;
    n:integer;
    obj:IntersectableClass;
begin
    t_o := VecSub(target,org);
    // [2] VhEC߂
    ShadowRay:=CreateRay(org, VecNormalize(t_o));
    isect := CreateIntersect;
    // [3] ܂ł̋̏ɂ
    isect.t := VecLen(t_o);
    n:=0;
    while n<ObjList.count do begin
      obj := IntersectableClass(objlist[n]);
      if (obj.intersect(isect, ShadowRay))  THEN BEGIN
          result:=FALSE;
          exit;
      END;
      n:=n+1;
    end;
    result:=TRUE;
end;

FUNCTION SceneClass.DiffuseLighting(p,n,lightPos:VectorRecord;
                         DiffuseColor,LightPower:SpectrumRecord):SpectrumRecord;
VAR
    l_p,l:VectorRecord;
    dot,r,factor:SINGLE;
BEGIN
    result:=Black;
    l_p:=VecSub(LightPos,p);
    l:=VecNormalize(l_p);
    dot:=VecDot(n,l);
    IF dot>0 THEN BEGIN
        IF Visible(p,LightPos) THEN BEGIN
            r:=VecLen(l_p);
            factor:=dot / (4*PI*r*r);
            result:=SpecMul(SpecScale(LightPower,factor),DiffuseColor);
            exit;
        END;
    END;
END;


BEGIN
    Randomize;
END.

Traceŗp





$Log: MLTUNIT.PAS $
Revision 2.6  2011/05/18 13:05:31  Average
_TvO̓

Revision 2.5  2011/05/17 16:43:00  Average
IntersectionRecord  R[h

Revision 2.4  2011/05/17 16:20:32  Average
MaterialR[h債Ƃ͖

Revision 2.3  2011/05/17 16:11:31  Average
xN^ZSRecordZ

Revision 2.2  2011/05/17 15:02:11  Average
Unit̎gpςĂ݂܂

@


2.6
log
@_TvO̓
@
text
@a111 4
    PiNGCreateClass=CLASS(MingViewClass)
        PROCEDURE CreateNewBitmap(xSize,ySize:INTEGER);
        PROCEDURE SetPixel(x,y:INTEGER;r,g,b:BYTE);
    END;
a667 14
PROCEDURE PiNGCreateClass.CreateNewBitmap(xSize,ySize:INTEGER);
BEGIN
    SetupHeader(xSize,ySize);
    e.SetBMPPointer(pBMPBody);
END;

PROCEDURE PiNGCreateClass.SetPixel(x,y:INTEGER;r,g,b:BYTE);
BEGIN
    e.pBMP^.RG[e.yOffset-(y*e.px)*3+x*3+0]:=AGanmma.qArray[b,0];
    e.pBMP^.RG[e.yOffset-(y*e.px)*3+x*3+1]:=AGanmma.qArray[g,1];
    e.pBMP^.RG[e.yOffset-(y*e.px)*3+x*3+2]:=AGanmma.qArray[r,2];
END;


d679 3
@


2.5
log
@Intersection  R[h
@
text
@d27 1
a27 3


    RayClass=CLASS
a28 2
        CONSTRUCTOR Create(o,d:VectorRecord);
        procedure ParamSet(o,d:VectorRecord);
d36 1
d39 7
d52 1
a52 1
    Intersection=Record
d60 2
a61 2
        function Intersect(var isect:Intersection;
                           Ray:RayClass):boolean;virtual;abstract;
d72 2
a73 2
        function Intersect(var isect:Intersection;
                           Ray:RayClass):boolean;override;
d82 2
a83 2
        function Intersect(var isect:Intersection;
                           ray:RayClass):boolean;override;
d92 2
a93 2
        function Intersect(var isect:Intersection;
                           ray:RayClass):boolean;override;
d103 2
a104 2
        function Trace(ray:RayClass;Depth:integer):SpectrumRecord;
        function FindNearestIntersection(ray:RayClass):Intersection;
d136 11
a146 2
function CreateIntersect:Intersection;
function HitIntersect(isect:intersection):boolean;
d244 1
a244 5
CONSTRUCTOR RayClass.Create(o,d:VectorRecord);
begin
    ParamSet(o,d);
end;
procedure RayClass.ParamSet(o,d:VectorRecord);
d246 2
a247 1
    org:=o;dir:=d;
d256 4
d268 1
a268 1
function CreateIntersect:Intersection;
d273 1
a273 1
function HitIntersect(isect:Intersection):boolean;
d287 2
a288 2
function SphereClass.Intersect(var isect:Intersection;
                                Ray:RayClass):boolean;
d322 1
a322 1
function PlaneClass.Intersect(var isect:Intersection;ray:RayClass):boolean;
d352 2
a353 2
function CheckedPlaneClass.Intersect(var isect:Intersection;
                                     ray:RayClass):boolean;
d368 36
d447 1
a447 8
function SceneClass.Trace(ray:RayClass;Depth:integer):SpectrumRecord;
var
    isect:Intersection;
    m:MaterialRecord;
    L,c:SpectrumRecord;
    ks,kd,kt:single;


d455 1
d460 1
a460 1
        Li := trace( RayClass.Create(p, r), depth);
d465 28
d494 47
d547 1
a547 1
    isect := FindNearestIntersection(ray);
d552 10
a561 1
    result:=TraceDiffuseReflection(isect.p,isect.n,isect.material.col,depth);
d594 1
a594 1
function SceneClass.FindNearestIntersection(ray:RayClass):Intersection;
d596 1
a596 1
    isect:Intersection;
d628 2
a629 2
    ShadowRay:RayClass;
    isect:Intersection;
d635 1
a635 1
    ShadowRay:=RayClass.Create(org, VecNormalize(t_o));
a691 27
    function reflect(v, n:VectorRecord):VectorRecord;
    begin
        result:= v.sub(n.scale(2 * v.dot(n)));
    end;
    function TraceReflection(p,n,v:VectorRecord;depth:integer):SpectrumRecord;
    var
        r:VectorRecord;
    begin
        r := reflect(v, n);
        result:=trace(RayClass.Create(p, r), depth);
    end;
    function refract(v,n:VectorRecord;eta_i,eta_t:single):VectorRecord;
    var
       VdotN,eta,d:single;
       a,b:VectorRecord;
    begin
        VdotN := v.dot(n);
        eta := eta_i / eta_t;
        d := 1.0 - sqr(eta) * (1.0 - sqr(VdotN));
        IF d>0 then begin
            a := v.sub(n.scale(VdotN)).scale(eta);
            b := n.scale(sqrt(d));
            result:=a.sub(b);
            exit;
        end;
        result:=Nil;
    end;
a692 14
    function TraceRefraction(p,n,v:VectorRecord;
                             eta_i,eta_t:single;
                             depth:integer):SpectrumRecord;
    var
        r:VectorRecord;
    begin
        r:=refract(v,n,eta_i,eta_t);
        IF r<>Nil then
           // 
           result:=trace(RayClass.Create(p,r),depth)
        else
           // S
           result:=TraceReflection(p, n, v, depth);
    end;
d696 3
a699 1
$Log: MLTUNIT.PAS $
@


2.4
log
@MaterialR[h債Ƃ͖
@
text
@d34 1
d48 1
a48 1
    IntersectionClass=Class
a51 2
        constructor create;
        function Hit:boolean;
d56 1
a56 1
        function Intersect(isect:IntersectionClass;
d68 1
a68 1
        function Intersect(isect:IntersectionClass;
d78 1
a78 1
        function Intersect(isect:intersectionClass;
d88 1
a88 1
        function Intersect(isect:intersectionClass;
d100 1
a100 1
        function FindNearestIntersection(ray:RayClass):IntersectionClass;
d132 4
d254 1
a254 1
constructor IntersectionClass.create;
d256 1
a256 1
    t:=ConstLengthFar;
d259 1
a259 1
function IntersectionClass.Hit:boolean;
d261 1
a261 1
    result:=((t<=0) or (t<ConstLengthLimit));
d273 1
a273 1
function SphereClass.Intersect(isect:IntersectionClass;
d308 1
a308 1
function PlaneClass.Intersect(isect:intersectionClass;ray:RayClass):boolean;
d338 1
a338 1
function CheckedPlaneClass.Intersect(isect:intersectionClass;
d399 1
a399 1
    isect:IntersectionClass;
d429 1
a429 1
    IF isect.hit=FALSE then begin
d466 1
a466 1
function SceneClass.FindNearestIntersection(ray:RayClass):IntersectionClass;
d468 1
a468 1
    isect:IntersectionClass;
d472 1
a472 1
    isect := IntersectionClass.Create;
d501 1
a501 1
    isect:IntersectionClass;
d508 1
a508 1
    isect := IntersectionClass.Create;
d611 3
@


2.3
log
@xN^ZSRecordZ
@
text
@d34 1
a34 1
    MaterialClass=CLASS
a38 1
        constructor Create(col_:SpectrumRecord);
d40 1
d50 1
a50 1
        Material:MaterialClass;
d64 1
a64 1
        Material:MaterialClass;
d68 1
a68 1
                           Material_:MaterialClass);virtual;
d76 1
a76 1
        Material:MaterialClass;
d78 1
a78 1
                           Material_:MaterialClass);virtual;
d85 1
a85 1
        Material2:MaterialClass;
d88 1
a88 1
                           Material_,Material2_:MaterialClass);virtual;
d102 1
a102 1
        function lighting(p,n:VectorRecord;m:MaterialClass):SpectrumRecord;
d131 1
d237 1
a237 1
constructor MaterialClass.Create(col_:SpectrumRecord);
d239 4
a242 4
    col:=col_;
    reflection:=0; //˗
    refraction:=0; //܂̊
    RefractiveRate := 1;  // ܗ
d263 1
a263 1
                               Material_:MaterialClass);
d298 1
a298 1
                              Material_:MaterialClass);
d328 1
a328 1
                                     Material_,Material2_:MaterialClass);
d397 1
a397 1
    m:MaterialClass;
d478 1
a478 1
function SceneClass.lighting(p,n:VectorRecord;m:MaterialClass):SpectrumRecord;
d607 4
a610 1
$Log: mltunit.pas $
@


2.2
log
@Unit̎gpςĂ݂܂
@
text
@d20 1
a20 1
    VectorClass=CLASS
d22 2
a23 11
        CONSTRUCTOR Create(x_,y_,z_:SINGLE);
        FUNCTION Add(V :VectorClass):VectorClass;
        FUNCTION Sub(V :VectorClass):VectorClass;
        FUNCTION Scale(S :SINGLE):VectorClass;
        FUNCTION Neg:VectorClass;
        FUNCTION len:SINGLE;
        FUNCTION Normalize:VectorClass;
        FUNCTION Dot(V :VectorClass):SINGLE;//
        FUNCTION Cross(V :VectorClass):VectorClass;//O
    END;
    SpectrumClass=CLASS
d25 3
a27 6
        CONSTRUCTOR Create(r_,g_,b_:SINGLE);
        FUNCTION Add(v:SpectrumClass):SpectrumClass;
        FUNCTION Mul(v:SpectrumClass):SpectrumClass;
        FUNCTION Scale(s:SINGLE):SpectrumClass;
        FUNCTION ColorToColor:ColorType;
    END;
d30 3
a32 3
        Org,Dir:VectorClass;
        CONSTRUCTOR Create(o,d:VectorClass);
        procedure ParamSet(o,d:VectorClass);
d35 1
a35 1
        col:SpectrumClass;
d39 1
a39 1
        constructor Create(col_:SpectrumClass);
d42 3
a44 3
        pos:VectorClass;
        power:SpectrumClass;
        constructor Create(pos_:VectorClass;power_:SpectrumClass);
d49 1
a49 1
        p,n:VectorClass;
d62 1
a62 1
        center:VectorClass;
d66 1
a66 1
        constructor Create(center_:VectorClass;
d74 1
a74 1
        n:VectorClass;
d77 1
a77 1
        constructor Create(p_,n_:VectorClass;
d86 1
a86 1
        constructor Create(p_,n_:VectorClass;
d94 1
a94 1
        Black,SkyColor:SpectrumClass;
d99 2
a100 2
        function random_dir_over_hemisphere(n:VectorClass):VectorClass;
        function Trace(ray:RayClass;Depth:integer):SpectrumClass;
d102 3
a104 3
        function lighting(p,n:VectorClass;m:MaterialClass):SpectrumClass;
        function Visible(Org,Target:VectorClass):boolean;
        FUNCTION DiffuseLighting(p,n,lightPos:VectorClass;
d106 1
a106 1
                                 LightPower:SpectrumClass):SpectrumClass;
d114 16
d136 1
a136 1
CONSTRUCTOR VectorClass.Create(x_,y_,z_:SINGLE);
d138 1
a138 1
    x:=x_;y:=y_;z:=z_;
d140 1
a140 1
FUNCTION VectorClass.Add(V :VectorClass):VectorClass;
d142 3
a144 1
    result:=VectorClass.Create(x+v.x,y+v.y,z+v.z);
d146 1
a146 1
FUNCTION VectorClass.Sub(V :VectorClass):VectorClass;
d148 3
a150 1
    result:=VectorClass.Create(x-v.x,y-v.y,z-v.z);
d152 1
a152 1
FUNCTION VectorClass.Scale(S :SINGLE):VectorClass;
d154 3
a156 1
    result:=VectorClass.Create(x*s,y*s,z*s);
d158 1
a158 1
FUNCTION VectorClass.Neg:VectorClass;
d160 3
a162 1
    result:=VectorClass.Create(-x,-y,-z)
d164 1
a164 1
FUNCTION VectorClass.len:SINGLE;
d166 1
a166 1
   result:=sqrt(x*x+y*y+z*z);
d168 2
a169 1
FUNCTION VectorClass.Normalize:VectorClass;
d171 1
a171 1
    result:=VectorClass.scale(1.0/len);
d173 1
a173 1
FUNCTION VectorClass.Dot(V :VectorClass):SINGLE;//
d175 1
a175 1
    result:=x*v.x+y*v.y+z*v.z;
d177 1
a177 1
FUNCTION VectorClass.Cross(V :VectorClass):VectorClass;//O
d179 3
a181 3
    result:=VectorClass.Create(y * v.z - v.y * z,
                               z * v.x - v.z * x,
                               x * v.y - v.x * y);
d185 1
a185 1
CONSTRUCTOR SpectrumClass.Create(r_, g_, b_:SINGLE);
d187 3
a189 1
    r := r_; g := g_; b := b_;
d192 1
a192 1
FUNCTION SpectrumClass.add(v:SpectrumClass):SpectrumClass;
d194 3
a196 1
    result:=SpectrumClass.Create(r + v.r, g + v.g, b + v.b);
d199 1
a199 1
FUNCTION SpectrumClass.Mul(v:SpectrumClass):SpectrumClass;
d201 3
a203 1
    result:=SpectrumClass.Create(r * v.r, g * v.g, b * v.b);
d205 1
a205 1
FUNCTION SpectrumClass.Scale(s:SINGLE):SpectrumClass;
d207 3
a209 1
    result:=SpectrumClass.Create(r * s, g * s, b * s);
d211 1
a211 1
FUNCTION SpectrumClass.ColorToColor:ColorType;
d220 3
a222 3
    i.r := RealToByte(r * 255);
    i.g := RealToByte(g * 255);
    i.b := RealToByte(b * 255);
d227 1
a227 1
CONSTRUCTOR RayClass.Create(o,d:VectorClass);
d231 1
a231 1
procedure RayClass.ParamSet(o,d:VectorClass);
d236 1
a236 1
constructor MaterialClass.Create(col_:SpectrumClass);
d244 1
a244 1
constructor LightClass.Create(pos_:VectorClass;power_:SpectrumClass);
d260 1
a260 1
constructor SphereClass.Create(center_:VectorClass;
d272 1
a272 1
    o_c:VectorClass;
d277 3
a279 3
    o_c:=ray.org.sub(center);
    b:=ray.dir.dot(o_c);
    c:=o_c.dot(o_c)-sqr(radius);
d287 2
a288 2
            isect.p:=ray.org.add(ray.dir.scale(t));
            isect.n:=isect.p.sub(center).normalize;
d296 1
a296 1
constructor PlaneClass.Create(p_,n_:VectorClass;
d299 2
a300 2
    n := n_.normalize;
    d := -p_.dot(n);
d309 1
a309 1
    v:=n.dot(ray.dir);
d314 1
a314 1
    t:=-(n.dot(ray.org)+d)/v;
d317 1
a317 1
        isect.p:=ray.org.add(ray.dir.scale(t));
d325 1
a325 1
constructor CheckedPlaneClass.Create(p_,n_:VectorClass;
d354 2
a355 2
    Black:=SpectrumClass.Create(0,0,0);
    SkyColor:=SpectrumClass.Create(0.7,0.75,0.8);
d370 1
a370 1
function SceneClass.random_dir_over_hemisphere(n:VectorClass):VectorClass;
d385 2
a386 2
            
            IF result.dot(n)<0 then result:=result.neg;
d393 1
a393 1
function SceneClass.Trace(ray:RayClass;Depth:integer):SpectrumClass;
d397 1
a397 1
    L,c:SpectrumClass;
d402 3
a404 3
    function TraceDiffuseReflection(p,n:VectorClass;
                                    diffuse_color:SpectrumClass;
                                    depth:integer):SpectrumClass;
d406 2
a407 2
        r:VectorClass;
        Li,fr:SpectrumClass;
d413 3
a415 3
        fr := diffuse_color.scale(1.0 / PI);
        dot := n.dot(r);
        result:=Li.mul(fr).scale(2 * PI * dot);
d477 1
a477 1
function SceneClass.lighting(p,n:VectorClass;m:MaterialClass):SpectrumClass;
d479 1
a479 1
    L,c:SpectrumClass;
d483 1
a483 1
    L:=Black;//SpectrumClass.Create(0,0,0);
d488 1
a488 1
        L:=L.add(c);
d493 1
a493 1
function SceneClass.Visible(Org,Target:VectorClass):boolean;
d495 1
a495 1
    t_o:VectorClass;
d501 1
a501 1
    t_o := target.sub(org);
d503 1
a503 1
    ShadowRay:=RayClass.Create(org, t_o.normalize);
d506 1
a506 1
    isect.t := t_o.len;
d519 2
a520 2
FUNCTION SceneClass.DiffuseLighting(p,n,lightPos:VectorClass;
                         DiffuseColor,LightPower:SpectrumClass):SpectrumClass;
d522 1
a522 1
    l_p,l:VectorClass;
d526 3
a528 3
    l_p:=LightPos.sub(p);
    l:=l_p.normalize;
    dot:=n.dot(l);
d531 1
a531 1
            r:=l_p.len;
d533 1
a533 1
            result:=LightPower.Scale(factor).mul(DiffuseColor);
d560 1
a560 1
    function reflect(v, n:VectorCLass):VectorClass;
d564 1
a564 1
    function TraceReflection(p,n,v:VectorClass;depth:integer):SpectrumClass;
d566 1
a566 1
        r:VectorClass;
d571 1
a571 1
    function refract(v,n:VectorClass;eta_i,eta_t:single):VectorClass;
d574 1
a574 1
       a,b:VectorClass;
d588 1
a588 1
    function TraceRefraction(p,n,v:VectorClass;
d590 1
a590 1
                             depth:integer):SpectrumClass;
d592 1
a592 1
        r:VectorClass;
d606 4
a609 1
$Log$
@


2.1
log
@pXƃ
@
text
@d44 1
d63 2
a64 2
        constructor create;virtual;
        function Hit:boolean;virtual;
d111 1
a131 1

d208 4
d254 1
d347 25
a377 27
    function reflect(v, n:VectorCLass):VectorClass;
    begin
        result:= v.sub(n.scale(2 * v.dot(n)));
    end;
    function TraceReflection(p,n,v:VectorClass;depth:integer):SpectrumClass;
    var
        r:VectorClass;
    begin
        r := reflect(v, n);
        result:=trace(RayClass.Create(p, r), depth);
    end;
    function refract(v,n:VectorClass;eta_i,eta_t:single):VectorClass;
    var
       VdotN,eta,d:single;
       a,b:VectorClass;
    begin
        VdotN := v.dot(n);
        eta := eta_i / eta_t;
        d := 1.0 - sqr(eta) * (1.0 - sqr(VdotN));
        IF d>0 then begin
            a := v.sub(n.scale(VdotN)).scale(eta);
            b := n.scale(sqrt(d));
            result:=a.sub(b);
            exit;
        end;
        result:=Nil;
    end;
a378 34
    function TraceRefraction(p,n,v:VectorClass;
                             eta_i,eta_t:single;
                             depth:integer):SpectrumClass;
    var
        r:VectorClass;
    begin
        r:=refract(v,n,eta_i,eta_t);
        IF r<>Nil then
           // 
           result:=trace(RayClass.Create(p,r),depth)
        else
           // S
           result:=TraceReflection(p, n, v, depth);
    end;
    // ̃_ȕ肷
    function random_dir_over_hemisphere(n:VectorClass):VectorClass;
    var
        x,y,z:single;
        v:VectorClass;
        ll:single;
    begin
        while true do begin
            x:=(random(2000)-1000);x:=x/1000;
            y:=(random(2000)-1000);y:=y/1000;
            z:=(random(2000)-1000);z:=z/1000;
            ll:=x*x+y*y+z*z;
            if ((ll>0)and(ll<1.0)) THEN BEGIN
                v:=VectorClass.Create(x,y,z).normalize;
                IF v.dot(n)<0 then v:=v.neg;
                result:=v;
                exit;
            END;
        end;
    end;
d537 47
d585 1
a585 1
power
@


1.5
log
@1.7ɑΉ
@
text
@d14 1
a14 1
    VaccumRefractiveIndex=1.0;
d49 1
a49 1
        refractive_index :single;  // ܗ
d105 1
a123 2
VAR
    Black:SpectrumClass;
d215 1
a215 1
    refractive_index := 1;  // ܗ
d327 2
d389 37
d435 1
a435 1
        result:=Black;
d438 1
d440 1
d452 2
a453 2
                               VaccumRefractiveIndex,
                               m.refractive_Index,
d466 3
a468 2
                                m.refractive_index,
                                VaccumRefractiveIndex, depth);
d564 1
a564 1
    Black := SpectrumClass.Create(0, 0, 0);
@


1.4
log
@mlt1.6ɑΉ
@
text
@d14 1
d48 2
d126 1
d214 3
a216 1
    reflection:=0;
d345 1
a345 1
    ks,kd:single;
d357 32
d396 7
a402 4
    IF isect.hit=FALSE then
        result:=Black
    else begin
        m := isect.material;
d409 9
a417 1
        kd := 1- ks;
d423 5
a427 1
    END;
d525 3
@


1.3
log
@*** empty log message ***
@
text
@d13 1
d46 1
d91 10
d106 1
a106 1
        function Trace(ray:RayClass):SpectrumClass;
d210 1
d293 24
d334 1
a334 1
function SceneClass.Trace(ray:RayClass):SpectrumClass;
d337 14
d352 5
d360 15
a374 2
    else
        result:=Lighting(isect.p,isect.n,isect.Material);
d398 1
a398 1
    L:=SpectrumClass.Create(0,0,0);
@


1.2
log
@mlt 1.5 ɑΉ
@
text
@d12 1
d97 1
d239 2
a240 2
        IF t<=0 then t:=-B+dR;
        IF ((t>0) and (isect.t>t)) then begin
d270 1
a270 1
    if ((t>0)and(isect.t>t)) then begin
d339 26
d371 1
d376 6
a381 6
        r:=l_p.len;
        factor:=dot / (4*PI*r*r);
        result:=LightPower.Scale(factor).mul(DiffuseColor);
    END
    ELSE BEGIN
        result:=Black;
@


1.1
log
@Initial revision
@
text
@d1 1
a1 1
unit MLTUNIT;
d6 1
a6 1
SysUtils,Math,MkBMP,VPUtils;
d8 4
d14 14
a27 14
    ColorType=Record
        r,g,b:byte;
    end;
    VectorClass=Class
        x,y,z:single;
        constructor Create(x_,y_,z_:single);
        function Add(V :VectorClass):VectorClass;
        function Sub(V :VectorClass):VectorClass;
        function Scale(S :single):VectorClass;
        function Neg:VectorClass;
        function len:single;
        function Normalize:VectorClass;
        function Dot(V :VectorClass):single;//
        function Cross(V :VectorClass):VectorClass;//O
d30 20
a49 6
        r,g,b:single;
        constructor Create(r_,g_,b_:single);
        function Add(v:SpectrumClass):SpectrumClass;
        function Mul(v:SpectrumClass):SpectrumClass;
        function Scale(s:single):SpectrumClass;
        function ColorToColor:ColorType;
d52 49
d102 2
a103 2
        procedure CreateNewBitmap(xSize,ySize:integer);
        procedure SetPixel(x,y:integer;r,g,b:byte);
d106 1
a106 1
var
d111 78
a188 1
constructor VectorClass.Create(x_,y_,z_:single);
d190 1
a190 1
    x:=x_;y:=y_;z:=z_;
d192 2
a193 1
function VectorClass.Add(V :VectorClass):VectorClass;
d195 1
a195 1
    result:=VectorClass.Create(x+v.x,y+v.y,z+v.z);
d197 2
a198 1
function VectorClass.Sub(V :VectorClass):VectorClass;
d200 2
a201 1
    result:=VectorClass.Create(x-v.x,y-v.y,z-v.z);
d203 2
a204 1
function VectorClass.Scale(S :single):VectorClass;
d206 1
a206 1
    result:=VectorClass.Create(x*s,y*s,z*s);
d208 2
a209 1
function VectorClass.Neg:VectorClass;
d211 1
a211 1
    result:=VectorClass.Create(-x,-y,-z)
d213 4
a216 1
function VectorClass.len:single;
d218 3
a220 1
   result:=sqrt(x*x+y*y+z*z);
d222 6
a227 1
function VectorClass.Normalize:VectorClass;
d229 18
a246 1
    result:=VectorClass.scale(1.0/len);
d248 3
a250 1
function VectorClass.Dot(V :VectorClass):single;//
d252 3
a254 1
    result:=x*v.x+y*v.y+z*v.z;
d256 4
a259 1
function VectorClass.Cross(V :VectorClass):VectorClass;//O
d261 15
a275 3
    result:=VectorClass.Create(y * v.z - v.y * z,
                               z * v.x - v.z * x,
                               x * v.y - v.x * y);
d279 1
a279 1
constructor SpectrumClass.Create(r_, g_, b_:single);
d281 2
a282 1
    r := r_; g := g_; b := b_;
d285 1
a285 1
function SpectrumClass.add(v:SpectrumClass):SpectrumClass;
d287 1
a287 1
    result:=SpectrumClass.Create(r + v.r, g + v.g, b + v.b);
d290 1
a290 1
function SpectrumClass.Mul(v:SpectrumClass):SpectrumClass;
d292 1
a292 1
    result:=SpectrumClass.Create(r * v.r, g * v.g, b * v.b);
d294 4
a297 1
function SpectrumClass.Scale(s:single):SpectrumClass;
d299 21
a319 1
    result:=SpectrumClass.Create(r * s, g * s, b * s);
d321 1
a321 1
function SpectrumClass.ColorToColor:ColorType;
d323 11
a333 5
    i:ColorType;
    function RealToByte(r:single):byte;
    begin
        IF r>255 then r:=255;
        result:=Trunc(r);
d335 1
a335 5
begin
    i.r := RealToByte(r * 255);
    i.g := RealToByte(g * 255);
    i.b := RealToByte(b * 255);
    result:=i;
d337 18
d357 2
a358 2
procedure PiNGCreateClass.CreateNewBitmap(xSize,ySize:integer);
begin
d361 1
a361 1
end;
d363 2
a364 2
procedure PiNGCreateClass.SetPixel(x,y:integer;r,g,b:byte);
begin
d368 1
a368 1
end;
@
