head	3.3;
access;
symbols;
locks;
comment	@ * @;


3.3
date	2011.05.19.15.15.06;	author Average;	state Exp;
branches;
next	3.2;

3.2
date	2011.05.19.15.10.25;	author Average;	state Exp;
branches;
next	3.1;

3.1
date	2011.05.19.14.27.17;	author Average;	state Exp;
branches;
next	;


desc
@@


3.3
log
@ƒ`ς܂
@
text
@UNIT ArtUnit;
INTERFACE
USES
    os2def,os2base,os2pmapi,MkBMP,Classes,SysUtils,MltUnit;

const
     wm_EndThread=wm_user+1;
     wm_RePaint=wm_user+2;
var
    ArtfyThread:TID;
    ClientThreadWnd:hwnd;

TYPE
    GraphDataClass=CLASS(MingViewClass)
        Cx,Cy:integer;
        JpegQuality:INTEGER;
        constructor Create;OverRide;
        PROCEDURE SetupHeader(px,py:INTEGER);
        FUNCTION GetDrawRect:RectL;
        PROCEDURE DrawBitmap(rect:RectL;ps:hps);
        PROCEDURE SaveFile(SaveSt:string);
        procedure SetPixel(x,y:integer;Col:ColorType);
        procedure Artify;

    END;


IMPLEMENTATION

{$IFDEF DEBUG}
Uses
    WinCrt;
{$ENDIF}


constructor GraphDataClass.Create;
BEGIN
    JpegQuality:=75;
    inherited Create;
END;

PROCEDURE  GraphDataClass.SetupHeader(px,py:INTEGER);
begin
	inherited SetupHeader(px,py);
	Cx:=px;Cy:=py;
end;

FUNCTION GraphDataClass.GetDrawRect:RectL;
VAR
    cx,cy :LONGINT;(**bitmap size**)
    rect  :RectL;
BEGIN
    cx:=pBMPBody^.bmpCx;
    cy:=pBMPBody^.bmpCy;
    rect.xLeft:=0;Rect.xRight:=cx;
    rect.yTop:=cy;rect.yBottom:=0;
//    rect.xRight:=(Rect.xRight div 8)*8;
    GetDrawRect:=Rect;
END;


PROCEDURE GraphDataClass.DrawBitmap(rect:RectL;ps:hps);
VAR
    RectSrc,RectDest:RectL;
    hbm:HBITMAP;
    rc:bool;
    SrcXYRatio,DestXYRatio:double;
    yValue,xValue,xDiv,yDiv:integer;
BEGIN
    hbm:=GpiCreateBitmap(ps,
                        pBMPBody^.InfoHeader2,
                        CBM_INIT,
                        pBMPBody^.RG,
                        pBMPBody^.Info2);
    RectSrc.yTop:=pBMPBody^.bmpcy;
    RectSrc.yBottom:=0;
    RectSrc.xLeft:=0;
    RectSrc.xRight:=pBMPBody^.bmpCx;

    SrcXYRatio:=RectSrc.xRight / RectSrc.yTop;
    DestXYRatio:=rect.xRight/rect.yTop;

    RectDest:=rect;

    IF SrcXYRatio>DestXYRatio then begin
        xValue:=Rect.xRight; xDiv:=0;
        yValue:=Round(Rect.xRight / SrcXYRatio);
        yDiv:=(rect.yTop-yValue) div 2;
        RectDest.yBottom:=yDiv;
        RectDest.yTop:=RectDest.yTop-yDiv;
    end
    else begin
        yValue:=Rect.yTop; yDiv:=0;
        xValue:=Round(Rect.yTop * SrcXYRatio);
        xDiv:=(Rect.xRight-xValue) div 2;
        RectDest.xLeft:=xDiv;
        RectDest.xRight:=RectDest.xRight-xDiv;
    end;

    rc:=WinDrawBitmap(PS,Hbm,@@RectSrc,@@RectDest,1, 0,DBM_STRETCH);
    IF rc=FALSE THEN BEGIN
        HALT;
    END;
    GpiDeleteBitmap(HBM);
END;




PROCEDURE GraphDataClass.SaveFile(SaveSt:string);
BEGIN
    JpegFileSave(SaveSt,JpegQuality);
    //PingFileSave(SaveSt);
END;



procedure GraphDataClass.SetPixel(x,y:integer;Col:ColorType);
var
    Suffix:LongInt;
begin
    suffix:=(x+(Cy-y)*Cx)*3;
    pBMPBody^.rg[suffix  ]:=Col.b;
    pBMPBody^.rg[suffix+1]:=Col.g;
    pBMPBody^.rg[suffix+2]:=Col.r;

end;

procedure GraphDataClass.Artify;
const
    MaxExpSize=3;
    MaxStep=16;
type
    pBMPArray=^BMPArray;
var
    i,j:integer;
    Col:ColorType;
begin

    for i:=0 to Cx-1 do begin
        for j:=0 to Cy-1 do begin
            Col.r:=round((i/Cx)*255);
            Col.g:=round((j/Cy)*255);
            Col.b:=128;
            SetPixel(i,j,Col);
        end;
    end;
    WinPostMsg(ClientThreadWnd,WM_EndThread,mparam(0),mparam(0));
end;

BEGIN
END.

ExtractFileName
TStringList
@


3.2
log
@Ƃ肠ArtifyɓꍞނƂ͐
@
text
@d15 1
d18 1
d42 5
@


3.1
log
@*** empty log message ***
@
text
@d8 1
a15 1

d22 1
a22 2
      private
        Cx,Cy:integer;
d115 1
a115 1
    suffix:=(x+y*Cx)*3;
a131 2
    Cx:=pBMPBody^.bmpCx;
    Cy:=pBMPBody^.bmpCy;
@
