head	4.2;
access;
symbols;
locks;
comment	@ * @;


4.2
date	2011.05.21.14.52.48;	author Average;	state Exp;
branches;
next	4.1;

4.1
date	2011.05.21.13.23.02;	author Average;	state Exp;
branches;
next	;


desc
@@


4.2
log
@摜TCYgALk\
@
text
@UNIT RPUnit;
INTERFACE
USES
    os2def,os2base,os2pmapi,MkBMP,Classes,SysUtils,RPCalc;


TYPE
    GraphDataClass=CLASS(MingViewClass)
        Cx,Cy:integer;
        JpegQuality:INTEGER;
        isFitPicture:boolean;
        constructor Create;OverRide;
        PROCEDURE SetupHeader(px,py:INTEGER);
        FUNCTION GetDrawRect:RectL;
        PROCEDURE DrawBitmap(rect:RectL;ps:hps);
        PROCEDURE SaveFile(SaveSt:string);
        procedure SetPixel(x,y:integer;Col:ColorType);

    END;


IMPLEMENTATION

{$IFDEF DEBUG}
Uses
    WinCrt;
{$ENDIF}


constructor GraphDataClass.Create;
BEGIN
    JpegQuality:=75;
    isFitPicture:=TRUE;
    inherited Create;
END;

PROCEDURE  GraphDataClass.SetupHeader(px,py:INTEGER);
begin
	inherited SetupHeader(px,py);
	Cx:=px;Cy:=py;
end;

FUNCTION GraphDataClass.GetDrawRect:RectL;
VAR
    cx,cy :LONGINT;(**bitmap size**)
    rect  :RectL;
BEGIN
    cx:=pBMPBody^.bmpCx;
    cy:=pBMPBody^.bmpCy;
    rect.xLeft:=0;Rect.xRight:=cx;
    rect.yTop:=cy;rect.yBottom:=0;
//    rect.xRight:=(Rect.xRight div 8)*8;
    GetDrawRect:=Rect;
END;


PROCEDURE GraphDataClass.DrawBitmap(rect:RectL;ps:hps);
VAR
    RectSrc,RectDest:RectL;
    hbm:HBITMAP;
    rc:bool;
    SrcXYRatio,DestXYRatio:double;
    yValue,xValue,xDiv,yDiv:integer;
BEGIN
    hbm:=GpiCreateBitmap(ps,
                        pBMPBody^.InfoHeader2,
                        CBM_INIT,
                        pBMPBody^.RG,
                        pBMPBody^.Info2);
    RectSrc.yTop:=pBMPBody^.bmpcy;
    RectSrc.yBottom:=0;
    RectSrc.xLeft:=0;
    RectSrc.xRight:=pBMPBody^.bmpCx;
    
    IF isFitPicture THEN BEGIN

        SrcXYRatio:=RectSrc.xRight / RectSrc.yTop;
        DestXYRatio:=rect.xRight/rect.yTop;

        RectDest:=rect;

        IF SrcXYRatio>DestXYRatio then begin
            xValue:=Rect.xRight; xDiv:=0;
            yValue:=Round(Rect.xRight / SrcXYRatio);
            yDiv:=(rect.yTop-yValue) div 2;
            RectDest.yBottom:=yDiv;
            RectDest.yTop:=RectDest.yTop-yDiv;
        end
        else begin
            yValue:=Rect.yTop; yDiv:=0;
            xValue:=Round(Rect.yTop * SrcXYRatio);
            xDiv:=(Rect.xRight-xValue) div 2;
            RectDest.xLeft:=xDiv;
            RectDest.xRight:=RectDest.xRight-xDiv;
        end;

        rc:=WinDrawBitmap(PS,Hbm,@@RectSrc,@@RectDest,1, 0,DBM_STRETCH);
    END 
    ELSE BEGIN
        RectDest.xLeft:=( (Rect.xRight-Rect.xLeft)-
                          (RectSrc.xRight-RectSrc.xLeft) ) div 2 
                          +Rect.xLeft;
        RectDest.yBottom:=( (Rect.yTop-Rect.yBottom)-
                            (RectSrc.yTop-RectSrc.yBottom) ) div 2
                          +Rect.yBottom;
        RectDest.yTop:= RectDest.yBottom+(RectSrc.yTop-RectSrc.yBottom);
        RectDest.xRight:= RectDest.xLeft+(RectSrc.xRight-RectSrc.xLeft);
        
        rc:=WinDrawBitmap(PS,Hbm,@@RectSrc,@@RectDest,1, 0,DBM_NORMAL);
    END;
    IF rc=FALSE THEN BEGIN
        HALT;
    END;
    GpiDeleteBitmap(HBM);
END;




PROCEDURE GraphDataClass.SaveFile(SaveSt:string);
BEGIN
    JpegFileSave(SaveSt,JpegQuality);
    //PingFileSave(SaveSt);
END;



procedure GraphDataClass.SetPixel(x,y:integer;Col:ColorType);
var
    Suffix:LongInt;
begin
    suffix:=(x+(Cy-y)*Cx)*3;
    pBMPBody^.rg[suffix  ]:=Col.b;
    pBMPBody^.rg[suffix+1]:=Col.g;
    pBMPBody^.rg[suffix+2]:=Col.r;

end;

BEGIN
END.

ExtractFileName
TStringList
@


4.1
log
@*** empty log message ***
@
text
@d4 1
a4 1
    os2def,os2base,os2pmapi,MkBMP,Classes,SysUtils,MltUnit;
d11 1
d33 1
d74 2
d77 2
a78 2
    SrcXYRatio:=RectSrc.xRight / RectSrc.yTop;
    DestXYRatio:=rect.xRight/rect.yTop;
d80 1
a80 1
    RectDest:=rect;
d82 29
a110 16
    IF SrcXYRatio>DestXYRatio then begin
        xValue:=Rect.xRight; xDiv:=0;
        yValue:=Round(Rect.xRight / SrcXYRatio);
        yDiv:=(rect.yTop-yValue) div 2;
        RectDest.yBottom:=yDiv;
        RectDest.yTop:=RectDest.yTop-yDiv;
    end
    else begin
        yValue:=Rect.yTop; yDiv:=0;
        xValue:=Round(Rect.yTop * SrcXYRatio);
        xDiv:=(Rect.xRight-xValue) div 2;
        RectDest.xLeft:=xDiv;
        RectDest.xRight:=RectDest.xRight-xDiv;
    end;

    rc:=WinDrawBitmap(PS,Hbm,@@RectSrc,@@RectDest,1, 0,DBM_STRETCH);
@
