head	4.7;
access;
symbols;
locks;
comment	@ * @;


4.7
date	2011.05.23.13.52.53;	author Average;	state Exp;
branches;
next	4.6;

4.6
date	2011.05.23.13.50.51;	author Average;	state Exp;
branches;
next	4.5;

4.5
date	2011.05.22.11.32.26;	author Average;	state Exp;
branches;
next	4.4;

4.4
date	2011.05.21.15.51.03;	author Average;	state Exp;
branches;
next	4.3;

4.3
date	2011.05.21.15.22.20;	author Average;	state Exp;
branches;
next	4.2;

4.2
date	2011.05.21.14.52.48;	author Average;	state Exp;
branches;
next	4.1;

4.1
date	2011.05.21.13.23.02;	author Average;	state Exp;
branches;
next	;


desc
@x͉摜𒆉
@


4.7
log
@n
@
text
@PROGRAM rp;
{$H+}
USES
os2def,os2base,os2pmapi,Widget,
SysUtils,Math,VPUtils,
uGetOpt,Render,XMLCfg;

{$PMTYPE PM}

{$I rp.inc}

{$R rp.res}

CONST
    MainItem:ARRAY [0..4] OF ToolbarData=(
            (NuID:IDB_RUN     ;cText:' Run Filter '),
//            (NuID:IDB_FILEOPEN;cText:' Open existing file '),
  //          (NuID:IDB_FILESAVE;cText:' Save file '),
            (NuID:IDB_ADJUST;cText:' Fit Picture'),
            (NuID:TB_SEPARATOR;cText:''),
            (NuID:IDB_EXIT    ;cText:' Exit Application'),

            (NuID:0)
      );

CONST
    DefaultSampleNum=8;
const
     wm_EndThread=wm_user+1;
     wm_RePaint=wm_user+2;
var
     RayPathThread:ULong;

CONST
    XMLConfName:string='RPcfg.xml';
    xPosPath='RP/window/x';
    yPosPath='RP/window/y';
    xWidthPath='RP/window/width';
    yHeightPath='RP/window/height';
    SamplingNumberPath='RP/Render/SamplingNumber';

TYPE
    RayPathOptionClass=Class
        cfg: TXMLConfig;
        xWidth,yHeight,xPos,yPos:integer;
        SamplingNumber:integer;
        procedure LoadCfg;
        procedure SaveCfg(xW,yH,x,y,sn:integer);
    end;

    RayPathTreacerClass=Class
        Fx,Fy:integer;
        Scene:SceneClass;
        Camera:CameraRecord;
        ViewGraph:GraphDataClass;
        SamplingNumber:integer;
        RayPathClientWnd:HWND;
        constructor Create(x,y:integer);virtual;
        FUNCTION CalcPixelColor(x,y:INTEGER):ColorType;
        procedure RunReander;virtual;
    END;

    TGraphicPaneWindowClass=CLASS(TPaneWindowClass)
        isOnReander:boolean;
        RayPathTracer:RayPathTreacerClass;
        OpenFileName:String;
        constructor Create(AN:HAB);OverRide;
        FUNCTION PaneHandler(window:hwnd;
                             msg:ULong;
                             mp1,mp2:MParam):MResult;OverRide;

    END;

FUNCTION  Calc(GPW:POINTER ):LONGINT;
VAR
    BF:RayPathTreacerClass;
BEGIN
    DosSetPriority( PRTYS_THREAD, PRTYC_IDLETIME, 16, 0 );
    BF:=RayPathTreacerClass(GPW);
    BF.RunReander;
END;

PROCEDURE ActiveSubMenu(hwndFrame:hwnd;ID_Menu,id:ULong;Active:BOOLEAN);
VAR
    hwndMenu,hwndSubMenu:HWnd;
    mi:MenuItem;
    rc:MResult;
BEGIN
    hwndMenu:=WinWindowFromID(hwndFrame,FID_MENU);
    WinSendMsg(hwndMenu,                  //* j[Eo[̃nh */
         MM_QUERYITEM,                    //* bZ[W        @@@@@@ */
         MPFROM2SHORT(ID_Menu, 1),    //* Tuj[ ID          */
         MParam(@@mi));                    //* MENUITEM w|C^[  */
    hwndSubMenu := mi.hwndSubMenu;       //* Tuj[̃nh   */

    IF Active THEN
        rc:=WinSendMsg(hwndSubMenu,
                   MM_SETITEMATTR,
                   MPFROM2SHORT(Id,1),
                   MPFROM2SHORT(MIA_CHECKED,MIA_CHECKED) )
    ELSE
        rc:=WinSendMsg(hwndSubMenu,
                   MM_SETITEMATTR,
                   MPFROM2SHORT(Id,1),
                   MPFROM2SHORT(MIA_CHECKED,Ord(FALSE)) );

END;

PROCEDURE RayPathOptionClass.LoadCfg;
VAR
    aSWP:swp;
    CfgPath:string;
    SN:integer;
BEGIN
    WinQueryWindowPos(HWND_DESKTOP, aSWP);

    xPos:=(aSWP.x+aSWP.cx div 8) ;
    yPos:=(aSWP.y+aSWP.cy div 8) ;
    xWidth:=(aSWP.cx div 4) *3 ;
    yHeight:=(aSWP.cy div 4) *3;
    SN:=DefaultSampleNum;

    cfgPath:=ExtractFilePath(ParamStr(0))+XMLConfName;
    cfg:=TXMLConfig.Create(cfgPath);
    xPos:=cfg.GetValueInteger(xPosPath,xPos);
    yPos:=cfg.GetValueInteger(yPosPath,yPos);
    xWidth:=cfg.GetValueInteger(xWidthPath,xWidth);
    yHeight:=cfg.GetValueInteger(yHeightPath,yHeight);
    SamplingNumber:=cfg.GetValueInteger(SamplingNumberPath,SN);
    cfg.Free;
END;

PROCEDURE RayPathOptionClass.SaveCfg(xW,yH,x,y,sn:integer);
VAR
    swap:Swp;
    cfgPath:string;
BEGIN
    cfgPath:=ExtractFilePath(ParamStr(0))+XMLConfName;

    cfg:=TXMLConfig.Create(cfgPath);
    cfg.SetValueInteger(xPosPath,x);
    cfg.SetValueInteger(yPosPath,y);
    cfg.SetValueInteger(xWidthPath,xW);
    cfg.SetValueInteger(yHeightPath,yH);
    cfg.SetValueInteger(SamplingNumberPath,SN);
    cfg.Free;
END;



constructor RayPathTreacerClass.Create(x,y:integer);
VAR
    RC:ColorType;
    S:SphereClass;
    CP:CheckedPlaneClass;
BEGIN
    ViewGraph:=GraphDataClass.Create;
    ViewGraph.SetupHeader(x,y);


    Camera:=CameraLookat(
                   CreateVector(0, 3, 8),   // _
                   CreateVector(0, 0, 0),     // _
                   CreateVector(0, 1, 0),  // 
                   GradToRad(40),          // p
                   ViewGraph.Cx,
                   ViewGraph.Cy);

    Scene:=SceneClass.Create;

    S:=  SphereClass.Create(
            CreateVector(-2.1,0,0),
            1,
            CreateMaterial(CreateSpectrum(0.9,0.1,0.9))
         );
    Scene.AddObj( S );

    S:=  SphereClass.Create(
            CreateVector(0,0,0),
            1,
            CreateMaterial(CreateSpectrum(0.9,0.9,0.1))
         );
    S.Material.Reflection:=0.8;
    Scene.AddObj(S) ;

    S:=  SphereClass.Create(
            CreateVector(2.1,0,0),
            1,
            CreateMaterial(CreateSpectrum(0.1,0.9,0.9))
         );
    S.Material.refraction:=0.9;
    S.Material.RefractiveRate:=1.3;
    Scene.AddObj(S);

    S:=  SphereClass.Create(
            CreateVector(0,4,-2),
            1,
            CreateMaterial(CreateSpectrum(0.9,0.9,1))
         );
    S.Material.EmissionColor:=CreateSpectrum(1,1,1);
    Scene.AddObj(S);

    CP:=CheckedPlaneClass.Create(
            CreateVector(0,-1,0),
            CreateVector(0,1,0),
            1,
            CreateMaterial(CreateSpectrum(0.9,0.9,0.9)),
            CreateMaterial(CreateSpectrum(0.1,0.1,0.1))
        );
    Scene.AddObj(CP);


    Scene.AddLight(
        LightClass.Create(
            CreateVector(1000,1000,1000),
            CreateSpectrum(1e8,1e8,1e8)
        )
    );
end;



FUNCTION RayPathTreacerClass.CalcPixelColor(x,y:INTEGER):ColorType;
VAR
    px,py:single;
    Ray:RayRecord;
    L,c:SpectrumRecord;
    i:integer;
BEGIN
    L := scene.Black;
    for i:=1 to SamplingNumber do begin
        px := random(1000)/1000.0;
        py := random(1000)/1000.0;
        Ray:=GetCameraRay(Camera,x+px,y+py);
        c := scene.trace(ray, 0);
    // [3] F𑫂킹
        L := SpecAdd(L,c);
    END;
  // [4] ςFԂ
    result:=SpecToColor(SpecScale(L,(1.0 / SamplingNumber) ));
END;


procedure RayPathTreacerClass.RunReander;
var
    Fx,Fy:integer;
begin
    FOR Fy:=0 TO ViewGraph.Cy-1 DO BEGIN
       IF Fy mod 30 =0 then
           WinPostMsg(RayPathClientWnd,WM_RePaint,mparam(0),mparam(0));

       FOR Fx:= 0 TO ViewGraph.Cx-1 DO BEGIN
           ViewGraph.SetPixel(Fx,Fy,CalcPixelColor(Fx,Fy));
       END;
    END;
    WinPostMsg(RayPathClientWnd,WM_EndThread,mparam(0),mparam(0));
end;



constructor TGraphicPaneWindowClass.Create(AN:HAB);
begin
    isOnReander:=FALSE;
    RayPathTracer:=Nil;
    RayPathTracer:=RayPathTreacerClass.Create(320,240);
    inherited Create(AN);
end;


FUNCTION TGraphicPaneWindowClass.PaneHandler(window:hwnd;
                     msg:ULong;
                     mp1,mp2:MParam):MResult;
var
    ps:hps;
    paintRect,CurRect:RectL;
    SaveFileName:String;
begin
    result:=0;
    case Msg of
        wm_Paint:begin
            WinQueryWindowRect(Window, CurRect);
            ps:= WinBeginPaint(window,NULLHANDLE,@@PaintRect);
            WinFillRect(ps,CurRect,clr_white);
            IF RayPathTracer<>Nil then
                    RayPathTracer.ViewGraph.DrawBitmap(CurRect,ps);
            WinEndPaint(ps);
        end;
        wm_RePaint:begin
            WinInvalidateRect(window,NIL,FALSE);
        end;
        wm_EndThread:begin
            DosKillThread(RayPathThread);
            isOnReander:=FALSE;
            WinInvalidateRect(window,NIL,FALSE);
            RayPathTracer.ViewGraph.PingFileSave('test.png');

        end;
        WM_COMMAND:BEGIN
            CASE SHORT1FROMMP(mp1) OF
                IDB_RUN:BEGIN
                    isOnReander:=TRUE;
                    RayPathTracer.RayPathClientWnd:=window;
                    RayPathThread:= VPBeginThread(Calc,5094000,RayPathTracer);
                END;
                IDB_ADJUST:BEGIN
                    RayPathTracer.ViewGraph.isFitPicture:=
                            Not(RayPathTracer.ViewGraph.isFitPicture);
                    ActiveSubMenu(hwndFrame,
                                  ID_FILEMENU,
                                  IDB_ADJUST,
                                  RayPathTracer.ViewGraph.isFitPicture);

                    WinInvalidateRect(window,NIL,FALSE);

                END;
                IDB_EXIT:
                    WinPostMsg(Window, WM_QUIT, 0, 0);
            END;
        END;
        else
            result:=inherited PaneHandler(Window,msg,mp1,mp2);
    end;
end;

VAR
    habAnchor   : HAB;
    hmqQueue    : HMQ;
    qmMsg       : QMSG;
    PaneWindow:TGraphicPaneWindowClass;
    GetOpt:GetOptClass;
    OptStr:String;
    lWidth,lHeight:uLong;
    RPOpt:RayPathOptionClass;
    swap:SWP;

BEGIN
    habAnchor := WinInitialize(0);
    hmqQueue := WinCreateMsgQueue(habAnchor, 0);

    PaneWindow:=TGraphicPaneWindowClass.Create(habAnchor);
 //   PaneWindow.CreateTab;
  //  PaneWindow.TabPane.AddTab('Tab',1);
    PaneWindow.CreateToolbar(@@MainItem);


   {************************************************************}
   {* get screen height and width                              *}
   {************************************************************}

   lWidth := WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN);

   lHeight := WinQuerySysValue(HWND_DESKTOP,SV_CYSCREEN);

   {************************************************************}
   {* if failed, display error, and set to default value       *}
   {************************************************************}

   if ( lWidth = 0 ) OR ( lHeight = 0 ) then
     begin
       lWidth := 640;
       lHeight := 480;
     end;

     RPOpt:=RayPathOptionClass.Create;



    {************************************************************}
    {* get screen height and width                              *}
    {************************************************************}

    IF PaneWindow.hwndFrame <> NULLHANDLE THEN BEGIN
        RPOpt.LoadCfg;
        PaneWindow.RayPathTracer.SamplingNumber:=RPOpt.SamplingNumber;
        WinSetWindowPos(PaneWindow.hwndFrame,
                      NULLHANDLE,
                      RPOpt.xPos,
                      RPOpt.yPos,
                      RPOpt.xWidth,
                      RPOpt.yHeight,
                      SWP_SIZE OR SWP_MOVE OR SWP_ACTIVATE OR SWP_SHOW);
        (**WinSetWindowPostoolbaȑȂ**)

        ActiveSubMenu( PaneWindow.hwndFrame,
                           ID_FILEMENU,
                           IDB_ADJUST,
                           PaneWindow.RayPathTracer.ViewGraph.isFitPicture);


        WHILE WinGetMsg(habAnchor,qmMsg,NULLHANDLE,0,0) DO BEGIN
            WinDispatchMsg( habAnchor,qmMsg);
        END;

    WinQueryWindowPos(PaneWindow.hwndFrame,swap);
        RPOpt.SaveCfg(swap.cx,swap.cy,swap.x,swap.y,
                      PaneWindow.RayPathTracer.SamplingNumber);

        WinDestroyWindow(PaneWindow.hwndFrame);
    END;
    WinDestroyMsgQueue(hmqQueue);
    WinTerminate(habAnchor);
END.


@


4.6
log
@*** empty log message ***
@
text
@d6 1
a6 1
uGetOpt,RPUnit,RPCalc,XMLCfg;
@


4.5
log
@RtBOt@@Cꍞ
@
text
@d50 1
a50 1
    
d161 1
a161 1
    CameraLookat(  Camera,
d363 1
a363 1
     
d365 1
a365 1
     
d393 1
a393 1
    
d397 1
a397 1
        
@


4.4
log
@ 摜̃tBbg\
@
text
@d6 1
a6 1
uGetOpt,RPUnit,RPCalc;
d27 1
a27 1
    SampleNum=16;
d34 8
d43 8
d56 1
d109 41
d231 1
a231 1
    for i:=1 to SampleNum do begin
d240 1
a240 1
    result:=SpecToColor(SpecScale(L,(1.0 / SampleNum) ));
d333 2
d363 3
d373 2
d377 4
a380 4
                      lWidth div 8,
                      lHeight div 8,
                      lWidth div 8*6,
                      lHeight div 8*6,
d393 5
@


4.3
log
@s뒆
@
text
@a78 6
    WinSendMsg(hwndSubMenu,                  //* j[Eo[̃nh */
         MM_QUERYITEM,                    //* bZ[W        @@@@@@ */
         MPFROM2SHORT(id, 1),    //* Tuj[ ID          */
         MParam(@@mi));                    //* MENUITEM w|C^[  */
    hwndSubMenu := mi.hwndSubMenu;       //* Tuj[̃nh   */

d104 1
a104 1
                   CreateVector(0, 3, 5),   // _
d134 1
a134 1
    S.Material.RefractiveRate:=1.5;
d138 1
a138 1
            CreateVector(0,4,0),
d238 1
a238 1
            
d254 1
a254 1
                            
d318 6
a323 6
        
        ActiveSubMenu(PaneWindow.hwndFrame,
                      ID_FILEMENU,
                      IDB_ADJUST,
                      false);
                      
@


4.2
log
@摜TCYgALk\
@
text
@d33 2
a34 1
type
d66 33
d256 5
d324 6
@


4.1
log
@*** empty log message ***
@
text
@d6 1
a6 1
uGetOpt,RPUnit,MltUnit;
d15 1
a15 1
    MainItem:ARRAY [0..3] OF ToolbarData=(
d19 1
d42 1
a42 1
        procedure RunFilter;virtual;
d46 2
a47 2
        isOnFilter:boolean;
        RayPathTreacer:RayPathTreacerClass;
d62 1
a62 1
    BF.RunFilter;
d76 1
a76 1
                   CreateVector(2, 1.5, 5),   // _
d78 1
a78 1
                   CreateVector(-0.5, 1, 0),  // 
d109 8
d158 1
a158 1
procedure RayPathTreacerClass.RunFilter;
d164 1
a164 1
           WinPostMsg(RayPathThread,WM_RePaint,mparam(0),mparam(0));
d177 3
a179 3
    isOnFilter:=FALSE;
    RayPathTreacer:=Nil;
    RayPathTreacer:=RayPathTreacerClass.Create(320,240);
d198 2
a199 2
            IF RayPathTreacer<>Nil then
                    RayPathTreacer.ViewGraph.DrawBitmap(CurRect,ps);
d207 1
a207 1
            isOnFilter:=FALSE;
d209 2
d215 9
a223 3
                    isOnFilter:=TRUE;
                    RayPathTreacer.RayPathClientWnd:=window;
                    RayPathThread:= VPBeginThread(Calc,5094000,RayPathTreacer);
@
